models/Consultas.php
<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "consultas".
 *
 * @property int $id
 * @property string|null $texto
 * @property string|null $tabla
 * @property string|null $sql
 * @property resource|null $resultados
 */
class Consultas extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'consultas';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['resultados'], 'string'],
            [['texto', 'tabla'], 'string', 'max' => 255],
            [['sql'], 'string', 'max' => 800],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'texto' => 'Texto',
            'tabla' => 'Tabla',
            'sql' => 'Sql',
            'resultados' => 'Resultados',
        ];
    }
}

controllers/ConsultasController.php
<?php

namespace app\controllers;

use app\models\Consultas;
use app\models\ConsultasSearch;
use kartik\mpdf\Pdf;
use Yii;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use yii\data\SqlDataProvider;

/**
 * ConsultasController implements the CRUD actions for Consultas model.
 */
class ConsultasController extends Controller
{
    /**
     * @inheritDoc
     */
    public function behaviors()
    {
        return array_merge(
            parent::behaviors(),
            [
                'verbs' => [
                    'class' => VerbFilter::className(),
                    'actions' => [
                        'delete' => ['POST'],
                    ],
                ],
            ]
        );
    }

    /**
     * Lists all Consultas models.
     *
     * @return string
     */
    public function actionIndex()
    {
        $searchModel = new ConsultasSearch();
        $dataProvider = $searchModel->search($this->request->queryParams);

        return $this->render('index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }

     public function actionListar()
    {
        $searchModel = new ConsultasSearch();
        $dataProvider = $searchModel->search($this->request->queryParams);

        return $this->render('listar', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }
    /**
     * Displays a single Consultas model.
     * @param int $id ID
     * @return string
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new Consultas model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return string|\yii\web\Response
     */
    public function actionCreate()
    {
        $model = new Consultas();

        if ($this->request->isPost) {
            if ($model->load($this->request->post()) && $model->save()) {
                return $this->redirect(['view', 'id' => $model->id]);
            }
        } else {
            $model->loadDefaultValues();
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing Consultas model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param int $id ID
     * @return string|\yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($this->request->isPost && $model->load($this->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Consultas model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param int $id ID
     * @return \yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Consultas model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param int $id ID
     * @return Consultas the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Consultas::findOne(['id' => $id])) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
    public function actionConsulta($id) {

        $consulta=Consultas::findOne($id);

       $dataProvider = new SqlDataProvider([
            'sql' => $consulta->sql,
            'pagination' => [
                'pageSize' => 10,
            ],
        ]);

        return $this->render('consultas', [
                    'columnas' => [],
                    "datos" => $dataProvider,
                    'texto' => $consulta->texto,
                    'titulo' => "Consulta {$id}",
        ]);
    }
    public function actionPdf(){

        $consultas=Consultas::find()->all();

        
        
        $contenido=$this->renderPartial("crearpdf",[
            "titulo" => Yii::$app->name,
            "descripcion" => "Consultas de Seleccion",
            "consultas" => $consultas,
        ]);


        $pdf = new Pdf([
            // set to use core fonts only
            'mode' => Pdf::MODE_CORE,
            // A4 paper format
            'format' => Pdf::FORMAT_A4,
            'marginTop' => 30,
            // portrait orientation
            'orientation' => Pdf::ORIENT_PORTRAIT,
            // stream to browser inline
            'destination' => Pdf::DEST_BROWSER,
            //'filename'=>Yii::getAlias('@app') . '/file/pdf/test.pdf',
            //'destination' => Pdf::DEST_FILE,
            // your html content input
            'content' => $contenido,
            // format content from your own css file if needed or use the
            // enhanced bootstrap css built by Krajee for mPDF formatting
            // '@vendor/kartik-v/yii2-mpdf/src/assets/kv-mpdf-bootstrap.min.css'
            'cssFile' => ['@app/web/css/kv-mpdf-bootstrap.css','@app/web/css/site.css'],
            //'cssFile' => '@app/web/css
            ///site.css',
            // any css to be embedded if required
            'cssInline' => '.kv-heading-1{font-size:18px}',
            // set mPDF properties on the fly
            'options' => [
                'title' => 'Alpe Formacion',
                'showWatermarkImage'=>true,
                //'defaultheaderfontsize'=>9,
            ],
            // call mPDF methods on the fly
            'methods' => [
                'SetHeader'=>[' | ' . "Aplicacion consultas" . ' | por Ramon Abramo'],
                'SetFooter'=>[strtoupper(Yii::$app->name) . ' | Alpe Formacion | Pagina {PAGENO}'],
                //'SetWatermarkImage'=>[Yii::getAlias('@web') . '/imgs/alpe.png',1,[34,38],[10,0]],
                'SetWatermarkImage'=>[Yii::getAlias('@web') . '/imgs/descarga.jpg',1,[25,25],[5,0]],

            ]
        ]);


        // return the pdf output as per the destination setting
        return $pdf->render();

    }
}

views/consultas/_form.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/** @var yii\web\View $this */
/** @var app\models\Consultas $model */
/** @var yii\widgets\ActiveForm $form */
?>

<div class="consultas-form">

    <?php $form = ActiveForm::begin(); ?>

    <?= $form->field($model, 'texto')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'tabla')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'sql')->textInput(['maxlength' => true]) ?>
    
    <div class="form-group">
        <?= Html::submitButton('Save', ['class' => 'btn btn-success']) ?>
    </div>

    <?php ActiveForm::end(); ?>

</div>

views/consultas/_search.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/** @var yii\web\View $this */
/** @var app\models\ConsultasSearch $model */
/** @var yii\widgets\ActiveForm $form */
?>

<div class="consultas-search">

    <?php $form = ActiveForm::begin([
        'action' => ['index'],
        'method' => 'get',
    ]); ?>

    <?= $form->field($model, 'id') ?>

    <?= $form->field($model, 'texto') ?>

    <?= $form->field($model, 'tabla') ?>

    <?= $form->field($model, 'sql') ?>

    
    <div class="form-group">
        <?= Html::submitButton('Search', ['class' => 'btn btn-primary']) ?>
        <?= Html::resetButton('Reset', ['class' => 'btn btn-outline-secondary']) ?>
    </div>

    <?php ActiveForm::end(); ?>

</div>

views/consultas/consultas.php
<?php

use yii\helpers\Html;
use yii\grid\GridView;

/* @var $this yii\web\View */
/* @var $dataProvider yii\data\ActiveDataProvider */


?>
<div class="emple-index">

    <h1><?= $titulo ?></h1>
    <h2><?= $texto?> </h2>

    <?php
       
        if(!is_null($datos)){
            if(($datos->count)>0){
                echo GridView::widget([
                    'dataProvider' => $datos,
                    'columns'=> $columnas,
                ]);
            }else{
                echo "no hay registros";
            }
        }
    ?>
    
    
</div>

views/consultas/crearpdf.php
<?php

/* @var $this yii\web\View */

use yii\data\ActiveDataProvider;
use yii\data\SqlDataProvider;
use yii\grid\GridView;
use yii\helpers\Html;

$this->title = $titulo;
?>
<div style="margin-top:50px;"> </div>
<div class="site-about pdfSalida">
    <div class="row">
        <div style="float:none" class="col-lg-8 center-block">
            <div class="panel panel-primary">
                <div class="panel-heading">
                    <h2 class="panel-title">
                        <?= $this->title ?>
                    </h2>
                </div>
                <div style="height: 600px" class="panel-body">
                    <?= $descripcion ?>
                
                    <div style="margin:30px;float:none" class="col-lg-6 center-block">
                            <div class="list-group">
                                <div class="list-group-item list-group-item-info">Las consultas a resolver:</div>

                                <?php
                                foreach ($consultas as $consulta){
                                        echo '<div class="list-group-item"><span style="line-height:20px;height:20px;border-radius:5px;width:60px;display:block;float:left" class="bg-info">' . "&nbsp;&nbsp;" . $consulta->id . "&nbsp;&nbsp;" . '</span><span stype="display:block;float:left">' . $consulta->texto . '</span></div>';
                                }
                                ?>
                            </div>
                    </div>
                </div>
            </div>
        </div>
    </div>

<div style="display: block; page-break-before: always;"> </div>

    <table class="tablas">
    <?php
    foreach($consultas as $consulta){
    ?>
    <tr>
        <td><?= $consulta->id ?></td>
        <td><?= $consulta->texto ?></td>
    </tr>
    <tr>
        <td colspan="2"><?= $consulta->sql ?></td>
    </tr>
    
    <?php
        
    }
    ?>
    </table>
</div>

views/consultas/create.php
<?php

use yii\helpers\Html;

/** @var yii\web\View $this */
/** @var app\models\Consultas $model */

$this->title = 'Create Consultas';
$this->params['breadcrumbs'][] = ['label' => 'Consultas', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="consultas-create">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

views/consultas/index.php
<?php

use app\models\Consultas;
use yii\helpers\Html;
use yii\helpers\Url;
use yii\grid\ActionColumn;
use yii\grid\GridView;

/** @var yii\web\View $this */
/** @var app\models\ConsultasSearch $searchModel */
/** @var yii\data\ActiveDataProvider $dataProvider */

$this->title = 'Consultas';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="consultas-index">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a('Create Consultas', ['create'], ['class' => 'btn btn-success']) ?>
    </p>

    <?php // echo $this->render('_search', ['model' => $searchModel]); ?>

    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'filterModel' => $searchModel,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],

            'id',
            'texto',
            'tabla',
            'sql',
            [
                'class' => ActionColumn::className(),
                'urlCreator' => function ($action, Consultas $model, $key, $index, $column) {
                    return Url::toRoute([$action, 'id' => $model->id]);
                 }
            ],
        ],
    ]); ?>


</div>

views/consultas/listar.php
<?php

use app\models\Consultas;
use yii\helpers\Html;
use yii\helpers\Url;
use yii\grid\ActionColumn;
use yii\grid\GridView;

/** @var yii\web\View $this */
/** @var app\models\ConsultasSearch $searchModel */
/** @var yii\data\ActiveDataProvider $dataProvider */

$this->title = 'Consultas';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="consultas-index">

    <h1><?= Html::encode($this->title) ?></h1>

    <?php // echo $this->render('_search', ['model' => $searchModel]); ?>

    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'pager' => [
            'firstPageLabel' => 'Primera',
            'lastPageLabel'  => 'Última'
        ],
        'filterModel' => $searchModel,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],
            'texto',
            //'tabla',
            ['class' => 'yii\grid\ActionColumn',
                    'header' => 'Consultas',
                    'template' => '{link}',
                    'buttons' => [
                        'link' => function ($url,$model) {
                            return Html::a(Html::a('Consulta', ['/consultas/consulta','id'=>$model->id],
                                    ['class'=>'btn btn-danger']) ,
                                $url);
                        },
            ],
        ],
    ],
    ]); ?>


</div>

views/consultas/update.php
<?php

use yii\helpers\Html;

/** @var yii\web\View $this */
/** @var app\models\Consultas $model */

$this->title = 'Update Consultas: ' . $model->id;
$this->params['breadcrumbs'][] = ['label' => 'Consultas', 'url' => ['index']];
$this->params['breadcrumbs'][] = ['label' => $model->id, 'url' => ['view', 'id' => $model->id]];
$this->params['breadcrumbs'][] = 'Update';
?>
<div class="consultas-update">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

views/consultas/view.php
<?php

use yii\helpers\Html;
use yii\widgets\DetailView;

/** @var yii\web\View $this */
/** @var app\models\Consultas $model */

$this->title = $model->id;
$this->params['breadcrumbs'][] = ['label' => 'Consultas', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
\yii\web\YiiAsset::register($this);
?>
<div class="consultas-view">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a('Update', ['update', 'id' => $model->id], ['class' => 'btn btn-primary']) ?>
        <?= Html::a('Delete', ['delete', 'id' => $model->id], [
            'class' => 'btn btn-danger',
            'data' => [
                'confirm' => 'Are you sure you want to delete this item?',
                'method' => 'post',
            ],
        ]) ?>
    </p>

    <?= DetailView::widget([
        'model' => $model,
        'attributes' => [
            'id',
            'texto',
            'tabla',
            'sql',
            
        ],
    ]) ?>

</div>